#include <iostream.h>
#include <winsock2.h>
#include <stdio.h>

#define RPSS_NUMOFUSERS 0x03
#define RPSS_STARTGAME 0x04
#define RPSS_SCISSOR 0x05
#define RPSS_ROCK 0x06
#define RPSS_PAPER 0x07
#define RPSS_QUIT 0x08

void main ( void )
{
	SOCKET s[3];
	sockaddr_in me;
	sockaddr you[2];
	int addr_size = sizeof (sockaddr);
	int num_players = 0;

	cout << "Rock, Paper, Scissor, Shoot! Advanced Server\n";
	cout << "By Stefan Hajnoczi\n\n";
	WSADATA w;
	int error = WSAStartup (0x0202,&w);
	if (error)
	{
		cout << "Error:  You need WinSock 2.2!\n";
		return;
	}
	if (w.wVersion!=0x0202)
	{
		cout << "Error:  Wrong WinSock version!\n";
		WSACleanup ();
		return;
	}

	s[0] = socket (AF_INET,SOCK_STREAM,0);
	me.sin_family = AF_INET;
	me.sin_port = htons (5555);
	me.sin_addr.s_addr = htonl (INADDR_ANY);
	if (bind(s[0],(LPSOCKADDR)&me,sizeof(me))==SOCKET_ERROR)
	{
		cout << "Error:  Unable to bind socket!\n";
		WSACleanup ();
		return;
	}
	if (listen(s[0],1)==SOCKET_ERROR)
	{
		cout << "Error:  Unable to listen!\n";
		WSACleanup ();
		return;
	}
	cout << "Listening for connections...\n";
	while (num_players<2)
	{
		s[num_players+1] = accept (s[0],&you[num_players],&addr_size);

		if (s[num_players+1]==INVALID_SOCKET)
		{
			cout << "Error:  Unable to accept connection!\n";
			WSACleanup ();
			return;
		}
		else
		{
			cout << "Player joined!\n";
			char buffer[2];
			sprintf (buffer,"%c%d",RPSS_NUMOFUSERS,num_players+1);
			send (s[num_players+1],buffer,2,0);
			num_players++;
		}
	}
	cout << "Starting Game!\n";
	closesocket (s[0]);
	char buffer[2];
	sprintf (buffer,"%c%d",RPSS_STARTGAME,0);
	error = send (s[1],buffer,2,0);
	if ((error==0)||(error==SOCKET_ERROR))
	{
		cout << "Error:  Player 1 quit!\n";
		WSACleanup ();
		return;
	}
	error = send (s[2],buffer,2,0);
	if ((error==0)||(error==SOCKET_ERROR))
	{
		cout << "Error:  Player 2 quit!\n";
		WSACleanup ();
		return;
	}
	char player1 = 0;
	char player2 = 0;
	while (true)
	{
		int error = recv (s[1],buffer,2,0);
		if ((error==0)||(error==INVALID_SOCKET))
		{
			cout << "Error:  Player 1 quit!\n";
			closesocket (s[2]);
			WSACleanup ();
			return;
		}
		if ((buffer[0]==RPSS_ROCK)||(buffer[0]==RPSS_SCISSOR)||(buffer[0]==RPSS_PAPER))
		{
			player1 = buffer[0];
		}
		if (buffer[0]==RPSS_QUIT)
		{
			sprintf (buffer,"%c%d",RPSS_QUIT,0);
			send (s[2],buffer,2,0);
			closesocket (s[1]);
			closesocket (s[2]);
			WSACleanup ();
			cout << "Player 1 quit\n";
			return;
		}

		error = recv (s[2],buffer,2,0);
		if ((error==0)||(error==INVALID_SOCKET))
		{
			cout << "Error:  Player 2 quit!\n";
			closesocket (s[1]);
			WSACleanup ();
			return;
		}
		if ((buffer[0]==RPSS_ROCK)||(buffer[0]==RPSS_SCISSOR)||(buffer[0]==RPSS_PAPER))
		{
			player2 = buffer[0];
		}
		if (buffer[0]==RPSS_QUIT)
		{
			sprintf (buffer,"%c%d",RPSS_QUIT,0);
			send (s[1],buffer,2,0);
			closesocket (s[1]);
			closesocket (s[2]);
			WSACleanup ();
			cout << "Player 2 quit\n";
			return;
		}

		if (((int)player1>0)&&((int)player2>0))
		{
			sprintf (buffer,"%c%d",player2,0);
			send (s[1],buffer,2,0);
			sprintf (buffer,"%c%d",player1,0);
			send (s[2],buffer,2,0);
			cout << "Round completed!\n";
		}
	}
	char a;
	cin >> a;
}